﻿using System.Collections.Generic;

namespace TestProject
{
    /// <summary>
    /// 항목 공급자 인터페이스
    /// </summary>
    /// <typeparam name="TItem">항목 타입</typeparam>
    public interface IItemProvider<TItem>
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Method

        #region 카운트 가져오기 - FetchCount()

        /// <summary>
        /// 카운트 가져오기
        /// </summary>
        /// <returns>카운트</returns>
        int FetchCount();

        #endregion
        #region 범위 가져오기 - FetchRange(startIndex, count)

        /// <summary>
        /// 범위 가져오기
        /// </summary>
        /// <param name="startIndex">시작 인덱스</param>
        /// <param name="count">카운트</param>
        /// <returns>항목 리스트</returns>
        IList<TItem> FetchRange(int startIndex, int count);

        #endregion
    }
}